<template>
  <div div="user">
    <b-jumbotron>
      <template slot="header">Order List creation form</template>

      <div>
        <b-alert :show="hasError" dismissible variant="danger">{{ alertMessage }}</b-alert>
      </div>
      <b-form @submit.stop.prevent="onSubmit">
        <b-form-group id="name-input-group" label="Name" label-for="name-input">
          <b-form-input
            id="name-input"
            name="name-input"
            v-model="$v.form.name.$model"
            :state="$v.form.name.$dirty ? !$v.form.name.$error : null"
            aria-describedby="name-input-live-feedback"
          ></b-form-input>

          <b-form-invalid-feedback id="name-input-live-feedback">Name should not be empty.</b-form-invalid-feedback>
        </b-form-group>

        <b-form-group id="groups-input-group" label="Criterion" label-for="groups-input">
          <label class="typo__label">Select single value</label>
          <multiselect
            v-model="form.criterion"
            :options="criteria"
            :multiple="false"
            :searchable="true"
            :close-on-select="false"
            :show-labels="false"
            :clear-on-select="false"
            :preserve-search="true"
            placeholder="Pick criterion"
            :preselect-first="false"
          >
            <template slot="selection" slot-scope="{ values, search, isOpen }">
              <span
                class="multiselect__single"
                v-if="form.criterion && !isOpen"
              >selected</span>
            </template>
          </multiselect>
          <!--  -->
        </b-form-group>

        <b-form-group id="groups-input-group" label="Groups" label-for="groups-input">
          <label class="typo__label">Select multiple values</label>
          <multiselect
            v-model="form.groups"
            :options="groups"
            :multiple="true"
            :searchable="true"
            :close-on-select="false"
            :show-labels="false"
            :clear-on-select="false"
            :preserve-search="true"
            placeholder="Pick groups"
            :preselect-first="false"
          >
            <template slot="selection" slot-scope="{ values, search, isOpen }">
              <span
                class="multiselect__single"
                v-if="form.groups.length && !isOpen"
              >{{ form.groups.length }} options selected</span>
            </template>
          </multiselect>
          <!--  -->
        </b-form-group>

        <b-button type="submit" variant="primary" :disabled="$v.form.$invalid">Submit</b-button>
      </b-form>
    </b-jumbotron>
  </div>
</template>

<script>
import { AXIOS } from "./http-common";
import { validationMixin } from "vuelidate";
import Multiselect from "vue-multiselect";
import { required, minLength } from "vuelidate/lib/validators";

export default {
  name: "NewOrderList",
  components: { Multiselect },
  mixins: [validationMixin],
  data() {
    return {
      criteria: [],
      groups: [],
      isDisabled: false,
      isTouched: false,
      isLoading: true,
      form: {
        name: null,
        criterion: null,
        groups: [],
      },
      alertMessage: "Request error",
      hasError: false
    };
  },
  validations: {
    form: {
      name: {
        required,
        minLength: minLength(1)
      }
    }
  },
  computed: {
    isInvalid() {
      return this.isTouched && this.form.groups.length === 0;
    }
  },
  methods: {
    limitText (count) {
      return `and ${count} other countries`
    },
    onChange(value) {
      this.value = value;
      if (value.indexOf("Reset me!") !== -1) this.value = [];
    },
    onSelect(option) {
      if (option === "Disable me!") this.isDisabled = true;
    },
    onTouch() {
      this.isTouched = true;
    },
    dispatchToOrder(name) {
      this.$router.push({ name: "Order", params: { orderName: name } });
    },
    postData() {
      AXIOS.post(`/edu/orders/new`, this.$data.form, {
        withCredentials: true
      })
        .then(
          response => {
            console.log(response);
            this.hasError = false;
            this.dispatchToOrder(this.$data.form.name);
          },
          error => {
            this.$data.alertMessage =
              error.response.data.length < 150
                ? error.response.data
                : "Request error. Please, report this error website owners";
            if (this.$data.alertMessage === "400: Bad JSON format") {
              if (this.$data.form.criterion === null && this.$data.form.groups.length === 0) {
                this.$data.alertMessage = "400: Missing groups and criterion";
              } else if (this.$data.form.criterion === null) {
                this.$data.alertMessage = "400: Missing criterion";
              } else if (this.$data.form.groups.length === 0) {
                this.$data.alertMessage = "400: Missing groups";
              }
            }
            this.hasError = true;
            console.log(error);
          }
        )
        .catch(e => {
          console.log(e);
          this.showAlert(
            "Server error. Please, report this error website owners"
          );
          this.hasError = true;
        });
    },
    loadGroups() {
      AXIOS.get(`/edu/groups`, {})
        .then(
          response => {
            console.log(response);
            this.groups = response.data;
            this.hasError = false;
          },
          error => {
            console.log(error);
            this.$data.alertMessage =
              error.response.data.length < 150
                ? error.response.data
                : "Request error. Please, report this error website owners";
            this.hasError = true;
            this.groups = [];
          }
        )
        .catch(e => {
          console.log(e);
          this.showAlert(
            "Server error. Please, report this error website owners"
          );
          this.groups = [];
          this.hasError = true;
        });
    },
    loadCriteria() {
      AXIOS.get(`/edu/criteria`, {})
        .then(
          response => {
            console.log(response);
            this.criteria = response.data;
            this.isLoading = false;
            this.hasError = false;
          },
          error => {
            this.isLoading = true;
            console.log(error);
            this.$data.alertMessage =
              error.response.data.length < 150
                ? error.response.data
                : "Request error. Please, report this error website owners";
            this.hasError = true;
            this.criteria = [];
          }
        )
        .catch(e => {
          this.isLoading = true;
          console.log(e);
          this.showAlert(
            "Server error. Please, report this error website owners"
          );
          this.criteria = [];
          this.hasError = true;
        });
    },
    onSubmit() {
      this.$v.form.$touch();
      if (this.$v.form.$anyError) {
        console.log(this.$v.form);
        console.log(this.$data.form);
        return;
      }

      this.postData();
    }
  },
  created() {
    this.loadGroups();
    this.loadCriteria();
  },
  beforeRouteUpdate(_, __, next) {
    this.loadGroups();
    this.loadCriteria();
    next();
  }
};
</script>

<style src="vue-multiselect/dist/vue-multiselect.min.css"></style>